'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Button = exports.StyledButton = undefined;

var _taggedTemplateLiteral2 = require('babel-runtime/helpers/taggedTemplateLiteral');

var _taggedTemplateLiteral3 = _interopRequireDefault(_taggedTemplateLiteral2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _templateObject = (0, _taggedTemplateLiteral3.default)(['\n  padding: ', ';\n  font-size: ', ';\n  display: flex;\n  font-family: PT Sans, sans-serif;\n  align-items: center;\n  justify-content: center;\n  transition: background 250ms ease-in-out, color 250ms ease-in-out;\n\n  cursor: ', ';\n\n  ', ';\n\n  ', ';\n'], ['\n  padding: ', ';\n  font-size: ', ';\n  display: flex;\n  font-family: PT Sans, sans-serif;\n  align-items: center;\n  justify-content: center;\n  transition: background 250ms ease-in-out, color 250ms ease-in-out;\n\n  cursor: ', ';\n\n  ', ';\n\n  ', ';\n']),
    _templateObject2 = (0, _taggedTemplateLiteral3.default)(['\n  pointer-events: none;\n'], ['\n  pointer-events: none;\n']),
    _templateObject3 = (0, _taggedTemplateLiteral3.default)(['\n  justify-content: flex-start;\n  align-items: center;\n'], ['\n  justify-content: flex-start;\n  align-items: center;\n']),
    _templateObject4 = (0, _taggedTemplateLiteral3.default)(['\n  justify-content: space-between;\n'], ['\n  justify-content: space-between;\n']),
    _templateObject5 = (0, _taggedTemplateLiteral3.default)(['\n  justify-content: flex-start;\n  align-items: center;\n  padding: 0;\n  height: 2.25rem;\n'], ['\n  justify-content: flex-start;\n  align-items: center;\n  padding: 0;\n  height: 2.25rem;\n']),
    _templateObject6 = (0, _taggedTemplateLiteral3.default)(['\n  justify-content: flex-start;\n  align-items: center;\n  flex-grow: ', ';\n  background-color: ', ';\n  transition: flex-grow 0.5s ease-in-out, background-color 0.5s ease-in-out;\n  height: 2.25rem;\n'], ['\n  justify-content: flex-start;\n  align-items: center;\n  flex-grow: ', ';\n  background-color: ', ';\n  transition: flex-grow 0.5s ease-in-out, background-color 0.5s ease-in-out;\n  height: 2.25rem;\n']),
    _templateObject7 = (0, _taggedTemplateLiteral3.default)(['\n  display: flex;\n  align-items: center;\n  justify-content: center;\n\n  flex-grow: ', ';\n\n  transition: flex-grow 0.5s ease-in-out;\n'], ['\n  display: flex;\n  align-items: center;\n  justify-content: center;\n\n  flex-grow: ', ';\n\n  transition: flex-grow 0.5s ease-in-out;\n']),
    _templateObject8 = (0, _taggedTemplateLiteral3.default)(['\n  pointer-events: none;\n  background-size: contain;\n  background-repeat: no-repeat;\n  height: 1.5rem;\n  margin-right: 1.5rem;\n  width: 1.5rem;\n  padding: 0.6rem;\n'], ['\n  pointer-events: none;\n  background-size: contain;\n  background-repeat: no-repeat;\n  height: 1.5rem;\n  margin-right: 1.5rem;\n  width: 1.5rem;\n  padding: 0.6rem;\n']),
    _templateObject9 = (0, _taggedTemplateLiteral3.default)(['\n  background-image: url(\'/static/google.svg\');\n'], ['\n  background-image: url(\'/static/google.svg\');\n']),
    _templateObject10 = (0, _taggedTemplateLiteral3.default)(['\n  background-image: url(\'/static/facebook.svg\');\n'], ['\n  background-image: url(\'/static/facebook.svg\');\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _SVGExpandLess = require('./svg/SVGExpandLess');

var _SVGExpandLess2 = _interopRequireDefault(_SVGExpandLess);

var _SVGExpandMore = require('./svg/SVGExpandMore');

var _SVGExpandMore2 = _interopRequireDefault(_SVGExpandMore);

var _defaultStyles = require('./defaultStyles');

var _tinycolor = require('tinycolor2');

var _tinycolor2 = _interopRequireDefault(_tinycolor);

var _SVGCross = require('./svg/SVGCross');

var _SVGCross2 = _interopRequireDefault(_SVGCross);

var _SVGFullscreen = require('./svg/SVGFullscreen');

var _SVGFullscreen2 = _interopRequireDefault(_SVGFullscreen);

var _SVGFullscreenExit = require('./svg/SVGFullscreenExit');

var _SVGFullscreenExit2 = _interopRequireDefault(_SVGFullscreenExit);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var getColor = function getColor(_ref) {
  var balance = _ref.balance,
      colors = _ref.colors,
      key = _ref.key,
      isDisabled = _ref.isDisabled,
      isInverted = _ref.isInverted,
      isOn = _ref.isOn,
      _ref$disabledDefault = _ref.disabledDefault,
      disabledDefault = _ref$disabledDefault === undefined ? {
    color: '#666',
    backgroundColor: '#fff'
  } : _ref$disabledDefault,
      onHover = _ref.onHover,
      hasTouch = _ref.hasTouch;

  var color = void 0,
      on = void 0,
      off = void 0;
  var on$ = colors.on,
      off$ = colors.off,
      disabled = colors.disabled,
      transitionType = colors.transition;

  if (isInverted) {
    on = off$;
    off = on$;
  } else {
    on = on$;
    off = off$;
  }

  if (isDisabled) {
    color = disabled && disabled[key] || disabledDefault[key];
  }
  if (onHover && !isDisabled && !hasTouch) {
    switch (transitionType) {
      case 'text':
      case 'mix':
        color = _tinycolor2.default.mix(on[key], off[key], balance).toString();
        break;
      case 'smooth':
        if (isOn === true) {
          color = (0, _tinycolor2.default)(on[key]).darken(balance / 5).toString();
        } else {
          color = (0, _tinycolor2.default)(off[key]).darken(balance / 5).toString();
        }
        break;
      case 'contrast':
        if (isOn === true) {
          color = (0, _tinycolor2.default)(off[key]).darken(balance / 5).toString();
        } else {
          color = (0, _tinycolor2.default)(on[key]).darken(balance / 5).toString();
        }
        break;
      default:
        break;
    }
  }
  if (!onHover && !isDisabled) {
    if (isOn) {
      color = on[key];
    } else {
      color = off[key];
    }
  }

  return color;
};

var backgroundColor = function backgroundColor(_ref2) {
  var props = (0, _objectWithoutProperties3.default)(_ref2, []);

  var getBackgroundColor = function getBackgroundColor(args) {
    return getColor((0, _extends3.default)({}, props, args, {
      key: 'backgroundColor'
    }));
  };
  return '\n  background-color: ' + getBackgroundColor() + ';\n  :hover {\n    background-color: ' + getBackgroundColor({
    onHover: true,
    balance: props.isOn ? 25 : 75
  }) + ';\n  }\n  :active {\n    background-color: ' + getBackgroundColor({
    onHover: true,
    balance: 50
  }) + ';\n  }  \n  ';
};

var color = function color(_ref3) {
  var props = (0, _objectWithoutProperties3.default)(_ref3, []);

  var getTextColor = function getTextColor(args) {
    return getColor((0, _extends3.default)({}, props, args, {
      key: 'color'
    }));
  };
  return '\n  color: ' + getTextColor() + ';\n  :hover {\n    color: ' + getTextColor({
    onHover: true,
    balance: props.isOn ? 25 : 75
  }) + ';\n  }\n  :active {\n    color: ' + getTextColor({
    onHover: true,
    balance: 50
  }) + ';\n  }  \n  ';
};

var StyledButton = exports.StyledButton = _styledComponents2.default.div(_templateObject, function (_ref4) {
  var size = _ref4.size;

  switch (size) {
    case 'none':
      return {};
    case 's':
      return '0.25rem 0.5rem';
    case 'm':
      return '0.5rem 0.75rem';
    case 'l':
      return '0.75rem 1rem';
    default:
      return {};
  }
}, function (_ref5) {
  var size = _ref5.size;

  switch (size) {
    case 'none':
      return {};
    case 's':
      return '1.25rem';
    case 'm':
      return '1.5rem';
    case 'l':
      return '1.75rem';
    default:
      return {};
  }
}, function (_ref6) {
  var isDisabled = _ref6.isDisabled;
  return isDisabled ? 'not-allowed' : 'pointer';
}, backgroundColor, color);

StyledButton.defaultProps = {
  colors: _defaultStyles.buttonStyles.semiTransparentNeutral
};
var StyledExpandLess = (0, _styledComponents2.default)(_SVGExpandLess2.default)(_templateObject2);
var StyledExpandMore = (0, _styledComponents2.default)(_SVGExpandMore2.default)(_templateObject2);
var GoogleButton = (0, _styledComponents2.default)(StyledButton)(_templateObject3);
var CaretdownButton = (0, _styledComponents2.default)(StyledButton)(_templateObject4);
var CancelButton = (0, _styledComponents2.default)(StyledButton)(_templateObject4);
var FacebookButton = (0, _styledComponents2.default)(StyledButton)(_templateObject3);
var MercuryButton = (0, _styledComponents2.default)(StyledButton)(_templateObject5);
var MercurySide = _styledComponents2.default.div(_templateObject6, function (_ref7) {
  var isOn = _ref7.isOn;
  return isOn ? 1 : 0.5;
}, function (_ref8) {
  var colors = _ref8.colors,
      isOn = _ref8.isOn;
  return isOn ? colors.off.backgroundColor : colors.on.backgroundColor;
});
var MercuryCenter = _styledComponents2.default.div(_templateObject7, function (_ref9) {
  var isOn = _ref9.isOn;
  return isOn ? 0.5 : 1;
});

var Icon = _styledComponents2.default.div(_templateObject8);

var GoogleIcon = (0, _styledComponents2.default)(Icon)(_templateObject9);

var FacebookIcon = (0, _styledComponents2.default)(Icon)(_templateObject10);

var Button = function Button(_ref10) {
  var _ref10$colors = _ref10.colors,
      colorsProp = _ref10$colors === undefined ? 'transparentNeutral' : _ref10$colors,
      _ref10$shouldRenderIc = _ref10.shouldRenderIcon,
      shouldRenderIcon = _ref10$shouldRenderIc === undefined ? true : _ref10$shouldRenderIc,
      _ref10$renderIcon = _ref10.renderIcon,
      renderIcon = _ref10$renderIcon === undefined ? function () {
    return null;
  } : _ref10$renderIcon,
      _ref10$dataTestId = _ref10.dataTestId,
      dataTestId = _ref10$dataTestId === undefined ? 'button' : _ref10$dataTestId,
      _ref10$type = _ref10.type,
      type = _ref10$type === undefined ? 'default' : _ref10$type,
      _ref10$isInverted = _ref10.isInverted,
      isInverted = _ref10$isInverted === undefined ? false : _ref10$isInverted,
      children = _ref10.children,
      containerRef = _ref10.containerRef,
      className = _ref10.className,
      style = _ref10.style,
      isOn = _ref10.isOn,
      onClick = _ref10.onClick,
      _ref10$isDisabled = _ref10.isDisabled,
      isDisabled = _ref10$isDisabled === undefined ? false : _ref10$isDisabled,
      _ref10$size = _ref10.size,
      size = _ref10$size === undefined ? 'm' : _ref10$size,
      props = (0, _objectWithoutProperties3.default)(_ref10, ['colors', 'shouldRenderIcon', 'renderIcon', 'dataTestId', 'type', 'isInverted', 'children', 'containerRef', 'className', 'style', 'isOn', 'onClick', 'isDisabled', 'size']);

  var colors = void 0;

  if (typeof colorsProp === 'string') {
    colors = _defaultStyles.buttonStyles[colorsProp];
  } else {
    colors = colorsProp;
  }

  var checksForTouch = function checksForTouch() {
    if (typeof document !== 'undefined') {
      return 'ontouchstart' in document.documentElement || navigator.maxTouchPoints > 0 || navigator.msMaxTouchPoints > 0;
    }
    return false;
  };

  var getButtonProps = function getButtonProps() {
    var _ref11 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    var _onClick = _ref11.onClick,
        className = _ref11.className,
        style = _ref11.style,
        props = (0, _objectWithoutProperties3.default)(_ref11, ['onClick', 'className', 'style']);

    //const getClassName = ({ className, isOn, isDisabled }) => {
    //  const baseClass = `button button--${type}`
    //  const baseDisabledClass = `button--disabled button--${type}--disabled`
    //  const baseToggleClass = `button--${type}--${isOn ? `on` : `off`}`
    //  if (!isDisabled) {
    //    if (typeof isOn !== `undefined`) {
    //      if (typeof className !== `undefined`) {
    //        return `${baseClass} ${baseToggleClass} ${className}`
    //      } else {
    //        return `${baseClass} ${baseToggleClass}`
    //      }
    //    } else {
    //      if (typeof className !== `undefined`) {
    //        return `${baseClass} ${className}`
    //      } else {
    //        return `${baseClass}`
    //      }
    //    }
    //  } else {
    //    if (typeof className !== `undefined`) {
    //      return `${baseClass} ${baseDisabledClass} ${className}`
    //    } else {
    //      return `${baseClass} ${baseDisabledClass}`
    //    }
    //  }
    //}
    if (isDisabled) {
      return {
        'data-testid': dataTestId + '-disabled',
        style: style
        //  className: getClassName({ className, isOn, isDisabled }),
      };
    }
    return (0, _extends3.default)({
      ref: containerRef,
      'data-testid': dataTestId,
      style: style,
      className: className,
      onClick: function onClick(e) {
        for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
          args[_key - 1] = arguments[_key];
        }

        e.stopPropagation();
        !isDisabled && _onClick && _onClick.apply(undefined, [e].concat(args));
      }
    }, props);
  };

  var commonProps = (0, _extends3.default)({
    getButtonProps: getButtonProps,
    size: size,
    colors: colors,
    isOn: isOn,
    isInverted: isInverted,
    isDisabled: isDisabled,
    hasTouch: checksForTouch()
  }, getButtonProps((0, _extends3.default)({
    onClick: onClick,
    className: className,
    style: style
  }, props)));
  var renderButtonWithIcon = function renderButtonWithIcon(_ref12) {
    var Button = _ref12.Button,
        Icon = _ref12.Icon;

    return typeof children === 'function' ? children((0, _extends3.default)({}, commonProps, { Icon: Icon })) : _react2.default.createElement(
      Button,
      (0, _extends3.default)({}, commonProps),
      children ? _react2.default.createElement(
        _react.Fragment,
        null,
        _react2.default.createElement(Icon, null),
        children
      ) : _react2.default.createElement(Icon, null)
    );
  };
  var renderChildren = function renderChildren(type) {
    var icon = void 0;
    switch (type) {
      case 'caretdown':
        icon = isOn ? _react2.default.createElement(StyledExpandLess, null) : _react2.default.createElement(StyledExpandMore, null);
        renderIcon = function renderIcon(props) {
          return isOn ? _react2.default.createElement(StyledExpandLess, (0, _extends3.default)({}, props)) : _react2.default.createElement(StyledExpandMore, (0, _extends3.default)({}, props));
        };

        return typeof children === 'function' ? children((0, _extends3.default)({ icon: icon, renderIcon: renderIcon }, commonProps)) : _react2.default.createElement(
          CaretdownButton,
          (0, _extends3.default)({}, commonProps),
          children ? _react2.default.createElement(
            _react.Fragment,
            null,
            children,
            renderIcon({
              style: { marginLeft: '0.75rem' }
            })
          ) : renderIcon()
        );
      case 'cancel':
        icon = _react2.default.createElement(_SVGCross2.default, { viewBox: '0 0 20 20', size: 16 });
        renderIcon = function renderIcon(props) {
          return _react2.default.createElement(_SVGCross2.default, (0, _extends3.default)({ viewBox: '0 0 20 20', size: 16 }, props));
        };
        return typeof children === 'function' ? children({ getButtonProps: getButtonProps, isMouseOver: isMouseOver, icon: icon }) : _react2.default.createElement(
          CancelButton,
          (0, _extends3.default)({}, commonProps),
          children ? _react2.default.createElement(
            _react.Fragment,
            null,
            _react2.default.createElement(
              'div',
              { style: { display: 'flex', justifyContent: 'space-between' } },
              children
            ),
            renderIcon({ style: { pointerEvents: 'none', marginLeft: '0.75rem' } })
          ) : renderIcon({ style: { pointerEvents: 'none' } })
        );
      case 'facebook':
        return renderButtonWithIcon({ Button: FacebookButton, Icon: FacebookIcon });

      case 'google':
        return renderButtonWithIcon({ Button: GoogleButton, Icon: GoogleIcon });

      case 'mercurydrop':
        renderIcon = shouldRenderIcon ? renderIcon ? renderIcon : function (props) {
          return isOn ? _react2.default.createElement(_SVGFullscreenExit2.default, (0, _extends3.default)({ viewBox: '0 0 20 20', size: 16 }, props)) : _react2.default.createElement(_SVGFullscreen2.default, (0, _extends3.default)({ viewBox: '0 0 20 20', size: 16 }, props));
        } : function () {
          return null;
        };

        return typeof children === 'function' ? children({
          getButtonProps: getButtonProps,
          renderIcon: renderIcon
        }) : _react2.default.createElement(
          MercuryButton,
          (0, _extends3.default)({}, commonProps),
          _react2.default.createElement(MercurySide, { isOn: isOn, colors: colors }),
          renderIcon(),
          _react2.default.createElement(
            MercuryCenter,
            { isOn: isOn },
            children
          ),
          renderIcon(),
          _react2.default.createElement(MercurySide, { isOn: isOn, colors: colors })
        );
      default:
        return typeof children === 'function' ? children((0, _extends3.default)({}, commonProps)) : _react2.default.createElement(
          StyledButton,
          (0, _extends3.default)({}, commonProps),
          children
        );
    }
  };

  return renderChildren(type);
};

exports.Button = Button;
exports.default = _react2.default.memo(Button);